var express = require('express') 
// Parses HTML requests 
,   bodyparser = require('body-parser')
// Lets you use all popular node.js template engines like dust
,   cons = require('consolidate')
,   dust = require('dustjs-linkedin')
,   mysql = require('mysql')
// Create app
,   app = express() 

// Make app global
GLOBAL.app = app 

// setup database
var connection = mysql.createConnection({
    host: 'localhost',
    user: 'root', 
    password: 'djseong', 
    database: 'node_seminar', 
}); 

// Set up middleware 
app.use(bodyparser.json()); 
app.use(bodyparser.urlencoded({extended : true})); 
app.use(express.static(__dirname + '/public') );

// Use dust
dust.debugLevel = "ERROR";
app.engine('dust', cons.dust)

// Set views
app.set('views', __dirname + '/views');
app.set('view engine', 'dust');

// Core stuff 
app.get('/', function(req, res, next) {
    res.render('hello');
})
app.get('/newpage', function(req, res, next) {
  res.render('newpage')
})
app.post('/newpage', function(req, res, next) {
  var email = req.body.email;
  var password = req.body.password;
  var values = [email, password]; 

  connection.query('INSERT INTO person (email, password) VALUES (?, ?)', values, function(err, result){
    if(err) console.log("error inserting")
  })
  res.redirect ("displayperson")
})
app.get('/displayperson', function(req, res, next) {
  connection.query('SELECT * FROM person', function (err, rows) {
    res.render('displayperson', 
        {'people' : rows
      });
  })
})

// Listen on port 3000
var server = app.listen(3000, function() {
  console.log("Listening on port %d", server.address().port)
})

module.exports = app;
